/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */


var gOpenedWindowTypes = [];

// function openWindowUniqueInstance(chromeURL, windowType, options, *args)
// Open a window if no windows of windowType exist. Otherwise, bring
// the window of windowType to the front. Parameters for this function
// are identical to window.openDialog()

// komodoWindowType stores window types that have been opened, so when
// komodo is closed, it can first close all the windows it has opened.

function openWindowUniqueInstance(chromeURL, windowType, options) {
    var _WMSvc = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                        .getService(Components.interfaces.nsIWindowMediator);
    var existingWindow = _WMSvc.getMostRecentWindow(windowType);
    gOpenedWindowTypes[windowType]=1;
    if (existingWindow) {
        existingWindow.focus();
        return existingWindow;
    } else {
        // Convert arguments into an array for use with apply(), and substitute
        // '_blank' for windowType to avoid weird Mozilla crashes
        var newArgs = new Array();
        for (var i = 0; i < arguments.length; i++) {
            if (i == 1) {
                newArgs[i] = '_blank';
            } else {
                newArgs[i] = arguments[i];
            }
        }

        // We'd like to focus this, too, to avoid the z-order problem
        // but this will crash for modal windows. Perhaps we could
        // grep through the options to determine modality?
        return window.openDialog.apply(window, newArgs);
    }
}


// function openWindowMultipleInstance(chromeURL, windowType, options, *args)
// Open a new window, regardless of existing windows. Use this instead of
// window.openDialog(). Parameters are identical to window.openDialog()
function openWindowMultipleInstance(chromeURL, windowType, options) {
  gOpenedWindowTypes[windowType]=1;
  // Convert arguments into an array for use with apply(), and substitute
  // '_blank' for windowType to avoid weird Mozilla crashes
  var newArgs = new Array();
  for (var i = 0; i < arguments.length; i++) {
    if (i == 1) {
      newArgs[i] = '_blank';
    } else {
      newArgs[i] = arguments[i];
    }
  }
  return window.openDialog.apply(window, newArgs);
}

function windowManager_init() {
    KomodoRegisterCanCloseHandler(windowManager_closeAll);
    KomodoRegisterOnUnloadHandler(windowManager_closeAll);
}

function windowManager_closeAll() {
    var _WMSvc = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                        .getService(Components.interfaces.nsIWindowMediator);

    // Check for other OPEN windows and close if there
    // This is expandable - just add your windowtype to the array
    var openWindow;
    for (var type in gOpenedWindowTypes)
    {
        do {
            openWindow = _WMSvc.getMostRecentWindow(type);
            if (openWindow) {
                openWindow.close();
                if (!openWindow.closed) {
                    return false;
                }
            }
        } while (openWindow);
    }
    return true;
}

function windowManager_getMainWindow() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
    return wm.getMostRecentWindow('Komodo');
}

